﻿Type=Service
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private manager As BleManager2
	Private ServiceId, ReadChar As String
End Sub

Sub Service_Create
	manager.Initialize("manager")
	ServiceId = UUID("0001")
	ReadChar = UUID("1001")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Private Sub Manager_StateChanged (State As Int)
	If State <> manager.STATE_POWERED_ON Then
		ToastMessageShow("Please enable Bluetooth", True)
	Else
		manager.Scan(Array(ServiceId))
	End If
End Sub


Private Sub Manager_DeviceFound (Name As String, DeviceId As String, AdvertisingData As Map, RSSI As Double)
	Log($"DeviceFound: ${Name}"$)
	manager.Connect2(DeviceId, False)
End Sub

Private Sub Manager_Connected (Services As List)
	Log("Connected")
	
	manager.SetNotify(ServiceId, ReadChar, True)
End Sub

Private Sub Manager_DataAvailable (SId As String, Characteristics As Map)
	Dim b() As Byte = Characteristics.Get(ReadChar)
	CallSub2(Main, "MessageArrived", BytesToString(b, 0, b.Length, "utf8"))
End Sub

Private Sub UUID(id As String) As String
#if B4A
	Return "0000" & id.ToLowerCase & "-0000-1000-8000-00805f9b34fb"
#else if B4I
	Return id.ToUpperCase
#End If
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
